#include <bits\stdc++.h>

using namespace std;
#define ll long long
#define F first
#define S second
mt19937 rnd(100);

vector <vector<ll>> g;
ll x, n, k, st, cost = 0;

ll f(ll u, ll p) {
    ll ret = 0;
    for (ll v: g[u])
        if (v != p)
            ret = max(ret, f(v, u) + 1);
    if (ret == x - 1 && p != st && u != st) {
        cost++;
        return -1;
    } else
        return ret;
}

ll ask(ll u) {
    st = u;
    ll l = 0, r = n, m;
    while (r - l > 1) {
        m = (r + l) / 2;
        x = m;
        cost = 0;
        f(u, -1);
        if (cost > k)
            l = m;
        else
            r = m;
    }
    return r;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll t, u, v;
    cin >> n >> k >> t;
    g.resize(n);
    for (int i = 1; i < n; ++i) {
        cin >> u >> v, u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    if (t == 0) {
        cout << ask(0);
    } else {
        for (int i = 0; i < n; ++i)
            cout << ask(i) << ' ';
    }
}
/*
3 1 0
1 2
2 3

5 2 1
1 2
1 3
2 4
2 5

10 1 1
1 2
2 3
3 4
4 5
5 6
6 7
7 8
8 9
9 10

*/
/*

*/
/*

*/
/*
Что за треш в Цшке?

Допустим для вершины ответ x.
Тогда мы точно проведем ребра во все те вершины у которых расстояние до листьев максимум икс - 1
Потом выкинем все вершины в поддереве вершины в которую мы провели ребро, включая основную.
Теперь мы точно сделаем все тоже самое.

Ну, условный квадрат уже есть.
Как определить ответ для вершины

Как найти ответ для вершины
Запускаемся ДФСом который возвращает глубину самой глубокой вершины в поддереве, ну типо
Если у вершины такая глубина икс - 1, то возвращаем -1 и прибавляем 1 к ответу.


Как сделать по другому?
Для каждой вершины ищем расстояние до самой глубокой вершины в ее поддереве.
Все числа записываем в массив.
Для фиксированного расстояния, ответ - количество чисел дающих остаток x - 1 при делении на x - 1.
Теперь для икса затраты == количество таких чисел кратных икс.

Ну, сначала напишу тупое решение.

Для вершины есть набор чисел в ее поддереве, а также набор чисел которые мы можем получить только пойдя наверх.


Ох. Проблема может быть в том, что бинпоиск делать не совсем корректно.
Хотя... Каждого следующего по значению числа не больше чем предыдущего.
Значит все ок должно быть.


*/
/*

*/
/*

*/
