#include <bits\stdc++.h>

using namespace std;
#define ll long long
#define F first
#define S second

ll n, m, mod = 1000000007;
vector<ll> cnt;
unordered_map<ll, ll> dp;

ll hhh(ll a, ll b, ll c) {
    return a * mod * mod + b * mod + c;
}

ll f(ll ind, ll h1, ll h2) {
    if (ind == m)
        return 1;

    ll h = hhh(ind, h1, h2);
    if (dp.count(h))
        return dp[h];

    ll ans = 0;
    for (int i = 0; i <= min(cnt[ind] - h1 - h2, min(cnt[ind + 1] - h2, cnt[ind + 2])); ++i)
        ans = (ans + f(ind + 1, h2, i)) % mod;
    dp[h] = ans;
    return ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m;
    cnt.resize(m + 2);
    ll h;
    for (int i = 0; i < n; ++i) {
        cin >> h;
        cnt[h - 1]++;
    }

    for (int i = 0; i + 2 < m; ++i) {
        h = cnt[i] % 3;
        if (cnt[i] < 0)
            break;
        cnt[i] -= h;
        cnt[i + 1] -= h;
        cnt[i + 2] -= h;
    }

    for (int i = 0; i < m; ++i)
        if (cnt[i] % 3 != 0 || cnt[i] < 0) {
            cout << 0;
            return 0;
        } else
            cnt[i] /= 3;

    cout << f(0, 0, 0);
}
/*
9 4
3 4 2 4 4 2 3 3 2

6 3
1 2 3 1 2 1

10 6
1 2 2 3 3 4 4 5 5 6

10 6
1 2 2 3 3 4 4 5 5 6

*/
/*

*/
/*
Выглядит как ДП с оптимизацией префф суммами.

Есть минимум.
У его количества есть какой-то остаток при делении на 3.
Значит мы знаем остаток при делении на 3 у количества операций второго типа на которых лежит наш элемент.

У первого операции второго типа начинаются строго в нем.
Представим, что мы их применили.
У количеств второго числа оказалась какая-то четность. С ним аналогично.

Применим остатки количеств как операции т.к. все равно придется это сделать.
Теперь каждое число кратно трем и количество операций каждого типа со стартом в нем кратно трем.

Поделим все значения на 3.
Теперь наши операции - вычесть 1 из одного числа, либо из трех чисел подряд.

Каждое значение до n/3

У посл. трех чисел кол-во вариантов равно минимуму.
Если перебирать четвертое с конца число, то пока минимум не в первых двух из последних
 вариантов по минимуму, а потом x-1, x-2..

Кстати, сумма всех чисел в новом массиве до n/3.

Напишу, думать лень, вдруг зайдет.

Так... М == 4


*/
/*

*/
/*

*/