#include <bits\stdc++.h>

using namespace std;
#define ll long long
#define F first
#define S second


struct st {
    vector<ll> se;
    ll sz;

    st(ll n) {
        ll k = 1;
        while (k < n)
            k *= 2;
        sz = k * 2;
        se.assign(sz, -1);
    }

    ll ask(ll u) {
        u += sz / 2;
        ll ans = se[u];
        while (u > 1) {
            u /= 2;
            if (se[u] != -2)
                ans = se[u];
        }
        return ans;
    }

    ll l, r, v;

    void f(ll _l, ll _r, ll _v) {
        l = _l, r = _r, v = _v;
        f0(0, sz / 2, 1);
    }

    void push(ll x) {
        if (se[x] == -2)
            return;
        se[x * 2] = se[x * 2 + 1] = se[x];
        se[x] = -2;
    }

    void f0(ll L, ll R, ll now) {
        if (L >= l && R <= r)
            se[now] = v;
        else if (L >= r || R <= l)
            return;
        else {
            push(now);
            f0(L, (R + L) / 2, now * 2);
            f0((R + L) / 2, R, now * 2 + 1);
        }
    }
};

ll timer = 0;
vector<ll> L, R, P, sz, clr, ans, ans1, pos1, pos2, pos3;
ll maD = 0;
st *st1;

struct stt {
    vector<ll> se, sum;
    ll sz;

    stt() {
        ll k = 1;
        while (k < timer)
            k *= 2;
        sz = k * 2;
        se.assign(sz, -1);
        sum.resize(sz);
        for (int i = 0; i < pos1.size(); ++i)
            sum[pos1[i] + k] = 1;
        while (--k)
            sum[k] = sum[k * 2] + sum[k * 2 + 1];
    }

    void ch(ll u, ll v) {
        u += sz / 2;
        sum[u] = v;
        while (u > 1) {
            u /= 2;
            sum[u] = sum[u * 2] + sum[u * 2 + 1];
        }
    }

    ll l, r;

    ll ask(ll _l, ll _r) {
        l = _l, r = _r;
        return ask(0, sz / 2, 1);
    }

    ll ask(ll L, ll R, ll now) {
        if (L >= l && R <= r)
            return sum[now];
        else if (L >= r || R <= l)
            return 0;
        else
            return ask(L, (R + L) / 2, now * 2) + ask((R + L) / 2, R, now * 2 + 1);
    }
};

ll ssz(ll u, ll d = 0) {
    if (!u)
        return 0;
    maD = max(maD, d);
    return sz[u] = ssz(L[u], d + 1) + 1 + ssz(R[u], d + 1);
}

void dfs(ll u = 1, ll cnt = 0) {
    if (!u)
        return;
    ans[u] = cnt;
    ll h = st1->ask(u);
    if (h == -1) {
        dfs(L[u], cnt + 1);
        dfs(R[u], cnt + 1);
    } else if (h == 0) {
        dfs(L[u], cnt);
        dfs(R[u], cnt + 1);
    } else {
        dfs(L[u], cnt);
        dfs(R[u], cnt);
    }
}

void dfs1(ll u = 1, ll cnt = 1) {
    if (!u)
        return;
    ans1[u] = cnt;
    dfs1(L[u], cnt);
    dfs1(R[u], sz[L[u]] + cnt);
}

void dfs2(ll u) {
    if (!u)
        return;
    pos1[u] = timer++;
    dfs2(L[u]);
    pos2[u] = timer++;
    dfs2(R[u]);
    pos3[u] = timer++;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    ll n, q;
    cin >> n >> q;
    L.resize(n + 1);
    R.resize(n + 1);
    P.resize(n + 1);
    sz.resize(n + 1);
    ans1.resize(n + 1);
    st1 = new st(n + 1);

    for (int i = 0; i < n; ++i) {
        cin >> L[i + 1] >> R[i + 1];
        P[L[i + 1]] = i + 1;
        P[R[i + 1]] = i + 1;
    }

    ssz(1);
    dfs1();

    vector<tuple<ll, ll, ll, ll>> reqs(q);

    bool gr5 = 1;

    ll h1, h2, h3, h4;
    for (int i = 0; i < q; ++i) {
        cin >> h1 >> h2;
        if (h1 == 1) {
            cin >> h3 >> h4;
            reqs[i] = {h1, h2, h3, h4};
            gr5 = gr5 && h2 == h3;
        } else {
            reqs[i] = {h1, h2, 0, 0};
        }
    }

    if ((n <= 5000 && q <= 5000 || maD <= 40)) {
        for (int i = 0; i < q; ++i) {
            h1 = get<0>(reqs[i]);
            h2 = get<1>(reqs[i]);
            if (h1 == 1) {
                h3 = get<2>(reqs[i]);
                h4 = get<3>(reqs[i]);
                st1->f(h2, h3 + 1, h4);
            } else {
                ll a = ans1[h2];
                ll h = st1->ask(h2);
                if (h == 0)
                    a += sz[L[h2]];
                else if (h == 1)
                    a += sz[L[h2]] + sz[R[h2]];

                while (h2 != 1) {
                    h3 = h2;
                    h2 = P[h2];

                    h = st1->ask(h2);
                    if (h == -1)
                        a++;
                    else if (h == 0 && R[h2] == h3)
                        a++;
                }

                cout << a << '\n';
            }
        }
    } else if (!gr5) {
        ans.resize(n + 1);

        bool ntp = 1;
        for (int i = 0; i < q; ++i) {
            h1 = get<0>(reqs[i]);
            h2 = get<1>(reqs[i]);
            if (h1 == 1) {
                h3 = get<2>(reqs[i]);
                h4 = get<3>(reqs[i]);
                st1->f(h2, h3 + 1, h4);
            } else {
                if (ntp) {
                    dfs();
                    ntp = 0;
                }
                ll a = ans1[h2];
                ll h = st1->ask(h2);
                if (h == 0)
                    a += sz[L[h2]];
                else if (h == 1)
                    a += sz[L[h2]] + sz[R[h2]];

                cout << a + ans[h2] << '\n';
            }
        }
    } else {
        pos1.resize(n + 1);
        pos2.resize(n + 1);
        pos3.resize(n + 1);
        clr.assign(n + 1, -1);

        dfs2(1);

        stt *st2 = new stt();

        for (int i = 0; i < q; ++i) {
            h1 = get<0>(reqs[i]);
            h2 = get<1>(reqs[i]);
            if (h1 == 1) {
                h3 = get<3>(reqs[i]);
                if (clr[h2] == -1)
                    st2->ch(pos1[h2], 0);
                else if (clr[h2] == 0)
                    st2->ch(pos2[h2], 0);
                else
                    st2->ch(pos3[h2], 0);

                clr[h2] = h3;

                if (clr[h2] == -1)
                    st2->ch(pos1[h2], 1);
                else if (clr[h2] == 0)
                    st2->ch(pos2[h2], 1);
                else
                    st2->ch(pos3[h2], 1);
            } else {
                ll a;
                if (clr[h2] == -1)
                    a = st2->ask(0, pos1[h2] + 1);
                else if (clr[h2] == 0)
                    a = st2->ask(0, pos2[h2] + 1);
                else
                    a = st2->ask(0, pos3[h2] + 1);
                cout << a << '\n';
            }
        }
    }
}
/*
5 5
3 4
0 0
5 2
0 0
0 0
2 2
1 1 3 1
2 5
1 3 3 0
2 3

*/
/*
5 11
2 0
3 0
4 0
5 0
0 0

2 5
1 1 1 1
2 5
1 2 2 1
2 5
1 3 3 1
2 5
1 4 4 1
2 5
1 5 5 1
2 5

*/
/*

*/
/*
Хех.
Предварительно это выглядит как задача на ДД.

Какие вершины находятся раньше текущей в таком обходе?

Из потомков
 Если -1, то никого
 Если в ней 0, то все в левом поддереве
 Если в ней 1, то все в обоих поддеревьях

Как узнавать ответ для не потомков в тупую?

Поднимаемся до корня.

Если мы перешли из левого поддерева
    При -1 ответ увиличивается на 1
    иначе не меняется
Если мы перешли из правого поддерева
    При -1 или 0 ответ увиличивается на 1 + левое поддерево
    иначе просто на левое поддерево

Ну, для каждой вершины для второго типа подъемов можно отдельно сщитать размер левого поддерева и отдельно прибавлять к ответу.
 Тогда нужно узнать сколько сверху подъемов налево в вершину с нулем, а также то, сколько сверху встречается -1.
Ну, и с изменениями.

Окей, пока напишу в тупую.

Зашли подгруппа с маленькими нм и с полным бинарным деревом.

Проблема в том, что нельзя полностью подниматься по дереву.

При наличии в ячейке -1, все значения в поддереве больше на 1.
При 0 то же но только в левом поддереве.
При обратных операциях уменьшается на 1 в тех же поддеревьях.

Есть изначальный ответ.

Вообще, похоже на ХЛД.


*/
/*
Что означает шестая подгруппа?
Вершины на отрезке либо отмеченны, либо нет.
Даются запросы, отметить номера вершин на определенном отрезке номеров.
Также требуется уметь узнавать количество отмеченных вершин среди предков текущей.

Для поиска количества нулей среди родителей по правому переходу,
 можно изменить дерево перенаправив все родительские ребра в первую вершину сверху, в правом поддереве которой мы находимся.

Сделаем типо тройной обход.
Для каждой вершины запихаем 2 нуля и 1 еденицу в ответ.
Изменение числа - перестановка еденицы из одного места в другое.
Номер элемента - сумма чисел левее него.

Пятую подгруппу можно так решить.


*/
/*
Ну, как хотябы подгруппы решать.
Первая и четвертая зашли.

Первая & - квадрат
Вторая & - каждый раз после запроса в тупую, проходимся ДФСом и для каждой вершины изначально считаем ответ.
Третья & - тоже самое впринципе, но операции ДОшкой.
Четвертая & - высота до лога

Пятая - делаем ДО на эйлеровом обходе и выполняя операцию просто меняем ответы для вершин в поддеревьях.




*/